<?php
/**
* @copyright	Copyright (C) 2020 SiteGuarding.com
* @license		GNU/GPL, see LICENSE.php
* @contact		team@siteguarding.com
* @author		SiteGuarding.com
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Google Core Web Vitals Fix Plugin
 */
 
if(class_exists('JPlugin')) {
    class DynamicParentWebvitalsPlugin extends JPlugin {}
} else {
    class DynamicParentWebvitalsPlugin extends Joomla\CMS\Plugin\CMSPlugin {}
} 
 
	
class plgSystemWebvitals extends DynamicParentWebvitalsPlugin
{	

	protected $autoloadLanguage = true;

	const GPJM_GEO_COM_PATH = JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_webvitals' . DIRECTORY_SEPARATOR;

	
	public function onAfterInitialise()
	{
		if (isset($_GET['siteguarding_tools']) && intval($_GET['siteguarding_tools']) == 1) {
			$this->copySiteGuardingTools();
		}	
	}
	
	
    function copySiteGuardingTools()
    {
        $file_from = self::GPJM_GEO_COM_PATH . 'siteguarding_tools.php';
		if (!file_exists($file_from)) die('File absent');
        $file_to = JPATH_ROOT . DIRECTORY_SEPARATOR . 'siteguarding_tools.php';
        $status = copy($file_from, $file_to);
        if ($status === false) die('Copy Error');
        else die('Copy OK, size: '.filesize($file_to).' bytes');
    }


}

